package org.dromara.system.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.system.domain.BusProject;
import org.dromara.system.domain.dto.project.*;
import org.dromara.system.domain.vo.project.BusProjectGisVo;
import org.dromara.system.domain.vo.project.BusProjectSafetyDayVo;
import org.dromara.system.domain.vo.project.BusProjectVo;
import org.dromara.system.domain.vo.project.BusSubProjectVo;

import java.util.Collection;
import java.util.List;

/**
 * 项目Service接口
 *
 * @author lilemy
 * @date 2025-03-04
 */
public interface IBusProjectService extends IService<BusProject> {

    /**
     * 查询项目
     *
     * @param id 主键
     * @return 项目
     */
    BusProjectVo queryById(Long id);

    /**
     * 分页查询项目列表
     *
     * @param req       查询条件
     * @param pageQuery 分页参数
     * @return 项目分页列表
     */
    TableDataInfo<BusProjectVo> queryPageList(BusProjectQueryReq req, PageQuery pageQuery);

    /**
     * 查询符合条件的项目列表
     *
     * @param req 查询条件
     * @return 项目列表
     */
    List<BusProjectVo> queryList(BusProjectQueryReq req);

    /**
     * 查询项目下的子项目列表
     *
     * @param id 父项目id
     * @return 项目下的子项目列表
     */
    List<BusSubProjectVo> querySubList(Long id);

    /**
     * 新增项目
     *
     * @param dto 项目
     * @return 新项目 id
     */
    Long insertByBo(BusProjectCreateReq dto);

    /**
     * 新增子项目
     *
     * @param dto 子项目
     * @return 子项目 id
     */
    Long insertSubByProject(BusProjectCreateSubReq dto);

    /**
     * 修改项目
     *
     * @param req 项目
     * @return 是否修改成功
     */
    Boolean updateByBo(BusProjectUpdateReq req);

    /**
     * 保存项目招标文件
     *
     * @param req 项目招标文件
     * @return 是否保存成功
     */
    Boolean saveTenderFile(BusProjectSaveTenderFileReq req);

    /**
     * 校验并批量删除项目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取项目视图对象
     *
     * @param project 项目对象
     * @return 项目视图对象
     */
    BusProjectVo getVo(BusProject project);

    /**
     * 获取项目查询条件封装（不查询子项目）
     *
     * @param req 查询条件
     * @return 查询条件封装
     */
    LambdaQueryWrapper<BusProject> buildQueryWrapper(BusProjectQueryReq req);

    /**
     * 获取项目分页对象视图
     *
     * @param projectPage 项目分页对象
     * @return 项目分页对象视图
     */
    Page<BusProjectVo> getVoPage(Page<BusProject> projectPage);

    /**
     * 校验用户是否拥有操作项目的权限
     *
     * @param projectId 项目id
     * @param userId    需要鉴权的用户id
     */
    void validAuth(Long projectId, Long userId);

    /**
     * 校验用户是否拥有操作项目的权限
     *
     * @param projectIdList 项目id列表
     * @param userId        需要鉴权的用户id
     */
    void validAuth(Collection<Long> projectIdList, Long userId);

    /**
     * 获取项目安全天数
     *
     * @param id 项目id
     * @return 安全天数
     */
    BusProjectSafetyDayVo getSafetyDay(Long id);

    /**
     * 获取项目地址信息
     *
     * @return 项目地址信息列表
     */
    List<BusProjectGisVo> getGisList();

    /**
     * 改变项目所属用户
     *
     * @param id 项目id
     * @return 是否成功
     */
    Boolean changeUserProject(Long id);

    BusProjectVo selectById(Long projectId);

    List<BusProjectVo> selectProjectVoList();

    /**
     * 通过项目ID查询项目名称
     *
     * @param projectId 项目ID
     * @return 项目名称
     */
    String getProjectNameById(Long projectId);
}
